cdef extern from "akmag.h":
    ctypedef struct CSRSprMat:
        int nnz
        int inx
        int *csrRowPtr_h
        int *csrColIdx_h
        double *csrValues_h

cdef extern from "dense2D_onthefly.h":
    void ComputeDenseMatrix_kdep_py(
        int nx,
        int *belm,
        int bnx,
        int bnelx,
        int *bnlist,
        double *xyz,
        double *nv,
        double *pang,
        int op,
        double k,
        double *D2Dk
    )

cdef extern from "rotation_mat.h":
    CSRSprMat rotation_matrix(
        double *m0_array[3],
        int nx
    )

#cdef extern from "xc_op.h":
#    CSRSprMat XC_OP(
#        char *fname
#    )

cdef extern from "fempreproc.h":
    int OperatorsFromMesh(
        double *xyz,
        int *ijk,
        int nx,
        int nelx,
        int dim,
        double Aex,
        double Msat,
        double dtet,
        int *bnlist,
        int *bnx,
        double *nv_carray,
        double *area_carray,
        CSRSprMat *xc,
        CSRSprMat *poiss,
        CSRSprMat *lap,
        CSRSprMat *div_x,
        CSRSprMat *div_y,
        CSRSprMat *grad_x,
        CSRSprMat *grad_y,
        double *pang,
        int *belm
    )
