//
// Created by attilak on 16.07.20.
//

#ifndef TETRAX_UTILS_H
#define TETRAX_UTILS_H

#include "akmag.h"

#define DMAX(X,Y) ((X) >= (Y) ? (X) : (Y))
#define SIGN(X) ((X) >= 0.0 ? 1.0 : -1.0)

/*----------------------------------------------------------------------*/
double dot_prod(double *a, double *b);
/*----------------------------------------------------------------------*/
double dot_prod2D(const double *a, const double *b);
/*----------------------------------------------------------------------*/
double vectabs(double *r);
/*----------------------------------------------------------------------*/
double vectnorm(double *r);
/*----------------------------------------------------------------------*/
double vectnorm2D(double *r);
/*----------------------------------------------------------------------*/
double vectabs2D(const double *r);
/*----------------------------------------------------------------------*/
void vectdiff2D(double *a, double *b, double *c);
/*----------------------------------------------------------------------*/
void vectdiff(double *a, double *b, double *c);
/*----------------------------------------------------------------------*/
double distP2Line(double *x0, double *x1, double *x2);
/*----------------------------------------------------------------------*/
double vectabsmaxcomp(double *a);
/*----------------------------------------------------------------------*/
double vectabsmaxcomp2D(double *a);
/*----------------------------------------------------------------------*/
void cross_prod(double *a, double *b, double *c);
/*----------------------------------------------------------------------*/
void normalize_v(double *a);
/*----------------------------------------------------------------------*/
void normalize_v2D(double *a);
/*----------------------------------------------------------------------*/
double Det2(double a11, double a12,
            double a21, double a22);
/*----------------------------------------------------------------------*/
double Det3(double a11, double a12, double a13,
            double a21, double a22, double a23,
            double a31, double a32, double a33);
/*----------------------------------------------------------------------*/
double vol_el6(double *a, double *b, double *c, double *d);
/*----------------------------------------------------------------------*/
double area_el2(const double *a, const double *b, const double *c);
/*----------------------------------------------------------------------*/
void dvcopy(double *rx, double *ry, int n, int inc);
/*----------------------------------------------------------------------*/
void MakeInvNodeElmList(AKElm *elm);
/*----------------------------------------------------------------------*/
void MakeAdjacentNodeList(AKElm *elm);
/*----------------------------------------------------------------------*/
int clean_mesh(AKElm *elm);
/*----------------------------------------------------------------------*/
double deg2rad(double phi_d);
/*----------------------------------------------------------------------*/
double rad2deg(double phi_r);
/*----------------------------------------------------------------------*/
//void phi2mx(double *w, AKVec *mmx);
/*----------------------------------------------------------------------*/
/*----------------------------------------------------------------------*/


#endif //TETRAX_UTILS_H
